#pragma comment(lib, "User32.lib")
#pragma comment(lib, "Comdlg32.lib")
#ifndef RZUF2_GAME_HEADER
#define RZUF2_GAME_HEADER
#include "includes.h"

using namespace std;

class Game
{

public:

	Game();
	~Game();

	void Init(const char* title, int xpos, int ypos, int width, int height, bool fullscreen);

	SDL_Texture* LoadTexture(const char* path, bool doOutput = true);
	void RenderText(TTF_Font* font, SDL_Color color, const char* text, int x, int y, int padding);
	void RenderRzufText(TTF_Font* font, const char* text, int x, int y, int padding, int scale);
	void DrawTexture(SDL_Texture* textureToDraw, int x, int y, int scale = 1, double rotation = 0);
	void HandleEvents();
	void Update();
	void RenderStart();
	void RenderFinish();
	void Clean();
	void SetIcon(const char* path);

	int windowWidth, windowHeight;
	int mouseX, mouseY;
	bool mouseL, mouseR;
	bool isRunning;
	bool wSizeChanged;

	int cnt;
	SDL_Window *window;
	SDL_Renderer* renderer;
	
};

#endif
