#ifndef MAIN
#define MAIN
#include "includes.h"
#include "Scenes.h"

Uint32 frameStart;
int frameTime;

Game game;
Scenes scenes;
MapManager mapManager;
SaveManager saveManager;
Sound soundManager;

int WinMain(HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPSTR     lpCmdLine,
	int       nShowCmd)
{

	//Inicjalizacja gry i okna
	
	game.windowWidth = WINDOW_WIDTH;
	game.windowHeight = WINDOW_HEIGHT;
	game.Init("sokoban.", SDL_WINDOWPOS_CENTERED, SDL_WINDOWPOS_CENTERED, WINDOW_WIDTH, WINDOW_HEIGHT, false);
	SDL_SetWindowResizable(game.window, SDL_TRUE);
	SDL_SetWindowMinimumSize(game.window, WINDOW_WIDTH, WINDOW_HEIGHT);
	game.SetIcon("Assets//icon.png");

	scenes.LoadResources(game);

	srand(time(NULL));

	while (game.isRunning)
	{
		frameStart = SDL_GetTicks();

		game.HandleEvents();
		game.Update();

		game.RenderStart();
		
		if (game.wSizeChanged) scenes.CalcDynamicPositions(game); 
		scenes.Update(game);
		
		game.RenderFinish();

		frameTime = SDL_GetTicks() - frameStart;
		if (1000 / MAX_FPS > frameTime)
		{
			SDL_Delay(1000 / MAX_FPS - frameTime);
		}
	}

	game.Clean();
	return 0;
}

#endif