#include "SaveManager.h"

SaveManager::SaveManager()
{

}

SaveManager::~SaveManager()
{

}

void SaveManager::ListSaves()
{
	string path = "Saves";
	savesCount = 0;
	for (const auto& entry : std::filesystem::directory_iterator(path)) savesCount++;

	this->saves = new Save[savesCount];
	int i = 0;

	for (const auto& entry : std::filesystem::directory_iterator(path))
	{
		string path{ entry.path().u8string() };
		this->saves[i] = LoadSave(path);
		i++;
	}

}

void SaveManager::CreateSave(string name, Map* map, bool restart, int timeRemaining, int scores[20], int mapid)
{

	remove(("Saves\\" + name + ".sav").c_str());
	ofstream savefile("Saves\\" + name + ".sav");
	if (savefile.is_open())
	{
		savefile << "name=" << name << "\n";
		savefile << "level=" << to_string((int)mapid) << "\n";
		savefile << "restart=" << to_string((int)restart) << "\n";
		savefile << "playerx=" << to_string(map->playerPosition[0]) << "\n";
		savefile << "playery=" << to_string(map->playerPosition[1]) << "\n";
		savefile << "playerr=" << to_string(map->playerRotation) << "\n";
		savefile << "timeleft=" << to_string(timeRemaining) << "\n";
		savefile << "mcount=" << to_string(map->movesCount) << "\n";
		savefile << "bcount=" << to_string(map->boxCount) << "\n";
		for (int i = 0; i < map->boxCount; i++)
		{
			savefile << "boxx" << to_string(i) << "=" << to_string(map->boxPosition[0][i]) << "\n";
			savefile << "boxy" << to_string(i) << "=" << to_string(map->boxPosition[1][i]) << "\n";
			savefile << "boxd" << to_string(i) << "=" << to_string(map->isDrowned[i]) << "\n";
		}
		if (name != "ZZ-EDITOR-")
			for (int i = 0; i < mapid; i++)
			{
				savefile << "score" << to_string(i) << "=" << to_string(scores[i]) << "\n";
			}
		savefile << "eof\n";
		savefile.close();
	}
}

bool SaveManager::checkInFile(string name, string line, int* intoutput, string* stringoutput)
{
	name = name + "=";

	if (line.find(name) != string::npos)
	{
		line = line.erase(0, name.length());

		if (intoutput != nullptr) *intoutput = stoi(line);
		if (stringoutput != nullptr) *stringoutput = line;
		return true;
	}
	else
	{
		return false;
	}
}

Save SaveManager::LoadSave(string name)
{
	Save newSave;
	string line;
	ifstream savefile(name);
	if (savefile.is_open())
	{
		while (getline(savefile, line))
		{
			if (checkInFile("name", line, nullptr, &newSave.name)) {}
			else if (checkInFile("level", line, &newSave.currentLevel)) {}
			else if (checkInFile("restart", line, &newSave.restartLevel)) {}
			else if (checkInFile("playerx", line, &newSave.playerPositionX)) {}
			else if (checkInFile("playery", line, &newSave.playerPositionY)) {}
			else if (checkInFile("playerr", line, &newSave.playerRotation)) {}
			else if (checkInFile("timeleft", line, &newSave.timeLeft)) {}
			else if (checkInFile("mcount", line, &newSave.movesCount)) {}
			else if (checkInFile("bcount", line, &newSave.boxCount))
			{
				newSave.boxPositionX = new int[newSave.boxCount];
				newSave.boxPositionY = new int[newSave.boxCount];
				newSave.isDrowned = new int[newSave.boxCount];
			}
			else
			{
				for (int i = 0; i < 20; i++)
				{
					checkInFile("score" + to_string(i), line, &newSave.levelScores[i]);
				}

				for (int i = 0; i < newSave.boxCount; i++)
				{
					checkInFile("boxx" + to_string(i), line, &newSave.boxPositionX[i]);
					checkInFile("boxy" + to_string(i), line, &newSave.boxPositionY[i]);
					checkInFile("boxd" + to_string(i), line, &newSave.isDrowned[i]);
				}
			}
		}
		savefile.close();
	}

	return newSave;
}

void SaveManager::Podium()
{
	this->podium[0] = this->podium[1] = this->podium[2] = -1;
	int podiumscore[3] = { 0,0,0 };

	for (int i = 0; i < this->savesCount; i++)
	{
		int sum = 0;

		for (int j = 0; j < 20; j++)
		{
			sum += this->saves[i].levelScores[j];
		}

		if (sum > podiumscore[0])
		{
			podiumscore[2] = podiumscore[1]; podium[2] = podium[1];
			podiumscore[1] = podiumscore[0]; podium[1] = podium[0];
			podiumscore[0] = sum; podium[0] = i;
		}
		else if (sum > podiumscore[1])
		{
			podiumscore[2] = podiumscore[1]; podium[2] = podium[1];
			podiumscore[1] = sum; podium[1] = i;
		}
		else if (sum > podiumscore[2])
		{
			podiumscore[2] = sum; podium[2] = i;
		}
	}
}