#ifndef SCENES
#define SCENES
#include "includes.h"

using namespace std;

//externy
extern SaveManager saveManager;
extern MapManager mapManager;
extern Sound soundManager;

class Scenes
{

	int currentScene = 0; // 0 - main menu // 1 - map menu // 2 - game // 3 - difficulty menu
	int prevScene = -1;
	int ticksInCurrentScene = 0;
	int ticksAtFirstMove = -1;
	int animationTimer = 0;
	int timerTime = -1;
	int selectedDifficulty = -1;
	int selectedSave = -1;
	string selectedSaveName = "";
	int pageno = 0;
	int lastPage = 0;
	int tempCursorX = 0;
	Map* amap = nullptr;
	Save* asave = nullptr;
	char buf[32], pktbuf[30];
	bool gamePaused = false;
	int scores[20];
	const char* editorerror = " ";
	int editorerrortime = 0;
	bool afteredit = false;
	bool promptsave = false;
	int selectedTool = 0;
	bool moved = false;
	bool pushed = false;

	//zasoby
	TTF_Font* Sans, * SmallerSans;
	Spritesheet playerTextures[3];
	SDL_Texture* congratulationsButton, * congratulationsHeader, * congratulationsArrow, * usermapsOverlay, * usermapsPlus, * editorOverlay, * tileOverlay, * lightOverlay, * darknessOverlay;
	SDL_Texture* logoTexture, * mapTextures[16], * difficultyBanner, * difficultyImages[3];
	Button trainingButton, newgameButton, continueButton, usermapsButton;
	Button mapButtons[3], nextMapButton, prevMapButton, usermapButtons[4];
	Button difficultyButtons[3];
	Button editorToolsButtons[9], editorLeftSideButtons[9];
	Button backButton, restartButton, pauseButton, unpauseButton, igmButtons[3];
	SDL_Texture* backOverlay, * restartOverlay, * pauseOverlay, * blackDot, * igmBackgrounds[9];
	SDL_Color timerColor;
	SDL_Texture* tableEntryImage, * tableHeaderImage, * medalImage[3];
	Button floppyButton, * floppyButtons;

	//stae
	const char* difficultyNames[3] = { "atwy", "Trudny", "Ekspert" };
	const int difficultySpeeds[3] = { 1,2,3 };
	const char* highlightStrings[20] =
	{
		" ",
		"Zamknij bez zapisywania",
		"Zapisz",
		"Zapisz jako nowa mapa",
		"Zapisz i zagraj",
		"Zmniejsz rozmiar X mapy",
		"Zwieksz rozmiar X mapy",
		"Zmniejsz rozmiar Y mapy",
		"Zwieksz rozmiar Y mapy",
		"Poprzednia postac",
		"Nastepna postac",
		"Buduj beton",
		"Buduj cegly",
		"Postaw skrzynie",
		"Postaw zatopiona skrzynie",
		"Postaw wode",
		"Postaw wlokno rzeczywistosci (poza obszarem mapy)",
		"Wyznacz miejsce docelowe skrzyni",
		"Postaw gracza",
		" ",
	};
	const char mapChars[9] = " #BDW.TP";

public:

	Scenes();
	~Scenes();

	void LoadResources(Game& localGame);
	void CalcDynamicPositions(Game& localGame);
	void MainMenuUpdate(Game& localGame);
	void MapMenuUpdate(Game& localGame);
	void DifficultyMenuUpdate(Game& localGame);
	void RenderGameMap(Game& localGame, bool dummy = false);
	void RenderGameDynamics(Game& localGame);
	void GameUpdate(Game& localGame);
	void SavesMenuUpdate(Game& localGame);
	void RenderEditorTools(Game& localGame);
	void MapEditorUpdate(Game& localGame);
	void CongratulationsUpdate(Game& localGame);
	void Update(Game& localGame);

};
#endif